org.apache.tomcat.dbcp.pool

## Interface ObjectPool<T>

- Type Parameters:
    `T` - the type of objects held in this pool
  All Known Implementing Classes:
    AbandonedObjectPool, BaseObjectPool, GenericObjectPool, SoftReferenceObjectPool, StackObjectPool

      public interface ObjectPool<T>

  A pooling interface.

  `ObjectPool` defines a trivially simple pooling interface. The only required methods are `borrowObject`, `returnObject` and `invalidateObject`.

  Example of use:

       Object obj = null;

       try {
           obj = pool.borrowObject();
           try {
               //...use the object...
           } catch(Exception e) {
               // invalidate the object
               pool.invalidateObject(obj);
               // do not return the object to the pool twice
               obj = null;
           } finally {
               // make sure the object is returned to the pool
               if(null != obj) {
                   pool.returnObject(obj);
              }
           }
       } catch(Exception e) {
             // failed to borrow an object
       }

  See `BaseObjectPool` for a simple base implementation.

  Since:
    Pool 1.0
  Author:
    Rodney Waldhoff, Sandy McArthur
  See Also:
    `PoolableObjectFactory`, `ObjectPoolFactory`, `KeyedObjectPool`, `BaseObjectPool`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addObject()` Create an object using the `factory` or other implementation dependent mechanism, passivate it, and then place it in the idle object pool.
    `T` | `borrowObject()` Obtains an instance from this pool.
    `void` | `clear()` Clears any objects sitting idle in the pool, releasing any associated resources (optional operation).
    `void` | `close()` Close this pool, and free any resources associated with it.
    `int` | `getNumActive()` Return the number of instances currently borrowed from this pool (optional operation).
    `int` | `getNumIdle()` Return the number of instances currently idle in this pool (optional operation).
    `void` | `invalidateObject(T obj)` Invalidates an object from the pool.
    `void` | `returnObject(T obj)` Return an instance to the pool.
    `void` | `setFactory(PoolableObjectFactory<T> factory)` Deprecated. to be removed in pool 2.0

- - ### Method Detail

    - #### borrowObject

          T borrowObject()
                         throws java.lang.Exception,
                                java.util.NoSuchElementException,
                                java.lang.IllegalStateException

      Obtains an instance from this pool.

      Instances returned from this method will have been either newly created with `makeObject` or will be a previously idle object and have been activated with `activateObject` and then validated with `validateObject`.

      By contract, clients must return the borrowed instance using `returnObject`, `invalidateObject`, or a related method as defined in an implementation or sub-interface.

      The behaviour of this method when the pool has been exhausted is not strictly specified (although it may be specified by implementations). Older versions of this method would return `null` to indicate exhaustion, newer versions are encouraged to throw a `NoSuchElementException`.

      Returns:
        an instance from this pool.
      Throws:
        `java.lang.IllegalStateException` - after `close` has been called on this pool.
        `java.lang.Exception` - when `makeObject` throws an exception.
        `java.util.NoSuchElementException` - when the pool is exhausted and cannot or will not return another instance.

    - #### returnObject

          void returnObject(T obj)
                            throws java.lang.Exception

      Return an instance to the pool. By contract, `obj` must have been obtained using `borrowObject` or a related method as defined in an implementation or sub-interface.
      Parameters:
        `obj` - a `borrowed` instance to be returned.
      Throws:
        `java.lang.Exception`

    - #### invalidateObject

          void invalidateObject(T obj)
                                throws java.lang.Exception

      Invalidates an object from the pool.

      By contract, `obj` must have been obtained using `borrowObject` or a related method as defined in an implementation or sub-interface.

      This method should be used when an object that has been borrowed is determined (due to an exception or other problem) to be invalid.

      Parameters:
        `obj` - a `borrowed` instance to be disposed.
      Throws:
        `java.lang.Exception`

    - #### addObject

          void addObject()
                         throws java.lang.Exception,
                                java.lang.IllegalStateException,
                                java.lang.UnsupportedOperationException

      Create an object using the `factory` or other implementation dependent mechanism, passivate it, and then place it in the idle object pool. `addObject` is useful for "pre-loading" a pool with idle objects. (Optional operation).
      Throws:
        `java.lang.Exception` - when `PoolableObjectFactory.makeObject()` fails.
        `java.lang.IllegalStateException` - after `close()` has been called on this pool.
        `java.lang.UnsupportedOperationException` - when this pool cannot add new idle objects.

    - #### getNumIdle

          int getNumIdle()
                         throws java.lang.UnsupportedOperationException

      Return the number of instances currently idle in this pool (optional operation). This may be considered an approximation of the number of objects that can be `borrowed` without creating any new instances. Returns a negative value if this information is not available.
      Returns:
        the number of instances currently idle in this pool or a negative value if unsupported
      Throws:
        `java.lang.UnsupportedOperationException` - deprecated: if this implementation does not support the operation

    - #### getNumActive

          int getNumActive()
                           throws java.lang.UnsupportedOperationException

      Return the number of instances currently borrowed from this pool (optional operation). Returns a negative value if this information is not available.
      Returns:
        the number of instances currently borrowed from this pool or a negative value if unsupported
      Throws:
        `java.lang.UnsupportedOperationException` - deprecated: if this implementation does not support the operation

    - #### clear

          void clear()
                     throws java.lang.Exception,
                            java.lang.UnsupportedOperationException

      Clears any objects sitting idle in the pool, releasing any associated resources (optional operation). Idle objects cleared must be `destroyed`.
      Throws:
        `java.lang.UnsupportedOperationException` - if this implementation does not support the operation
        `java.lang.Exception`

    - #### close

          void close()
                     throws java.lang.Exception

      Close this pool, and free any resources associated with it.

      Calling `addObject()` or `borrowObject()` after invoking this method on a pool will cause them to throw an `IllegalStateException`.

      Throws:
        `java.lang.Exception` - deprecated: implementations should silently fail if not all resources can be freed.

    - #### setFactory

          @Deprecated
          void setFactory(PoolableObjectFactory<T> factory)
                          throws java.lang.IllegalStateException,
                                 java.lang.UnsupportedOperationException

      Deprecated. to be removed in pool 2.0
      Sets the `factory` this pool uses to create new instances (optional operation). Trying to change the `factory` after a pool has been used will frequently throw an `UnsupportedOperationException`. It is up to the pool implementation to determine when it is acceptable to call this method.
      Parameters:
        `factory` - the `PoolableObjectFactory` used to create new instances.
      Throws:
        `java.lang.IllegalStateException` - when the factory cannot be set at this time
        `java.lang.UnsupportedOperationException` - if this implementation does not support the operation

Copyright © 2000-2020 Apache Software Foundation. All Rights Reserved.